Index: src/Actions/WorldAction/StepWorldTimeAction.cpp
===================================================================
--- src/Actions/WorldAction/StepWorldTimeAction.cpp	(revision d247507d666bbcdf34b0793aa013fb337a73385a)
+++ src/Actions/WorldAction/StepWorldTimeAction.cpp	(revision d247507d666bbcdf34b0793aa013fb337a73385a)
@@ -0,0 +1,111 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2016 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * StepWorldTimeAction.cpp
+ *
+ *  Created on: Sep 27, 2016
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/Verbose.hpp"
+#include "World.hpp"
+#include "WorldTime.hpp"
+
+#include <iostream>
+#include <string>
+
+#include "Actions/WorldAction/StepWorldTimeAction.hpp"
+
+using namespace MoleCuilder;
+
+// if both are given, we use backwards
+static int getSteps(const unsigned int _forward, const unsigned int _backward)
+{
+  int steps = 0;
+  if (_backward > 0)
+    steps = -_backward;
+  else
+    steps = _forward;
+
+  return steps;
+}
+
+// and construct the stuff
+#include "StepWorldTimeAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+ActionState::ptr WorldStepWorldTimeAction::performCall() {
+  // create undo state
+  int oldtime;
+  oldtime = WorldTime::getTime();
+  WorldStepWorldTimeState *UndoState = new WorldStepWorldTimeState(oldtime, params);
+
+  const int steps = getSteps(params.steps_forward.get(), params.steps_backward.get());
+
+  if ((oldtime + steps) < 0) {
+    ELOG(1, "Cannot step back before time step #0.");
+    return Action::failure;
+  }
+  World::getInstance().setTime(oldtime+steps);
+  LOG(0, "Current time step is now: " << WorldTime::getTime() << ".");
+  return ActionState::ptr(UndoState);
+}
+
+ActionState::ptr WorldStepWorldTimeAction::performUndo(ActionState::ptr _state) {
+  WorldStepWorldTimeState *state = assert_cast<WorldStepWorldTimeState*>(_state.get());
+
+  World::getInstance().setTime(state->oldtime);
+  LOG(0, "Current time step is now again: " << WorldTime::getTime() << ".");
+
+  return ActionState::ptr(_state);
+}
+
+ActionState::ptr WorldStepWorldTimeAction::performRedo(ActionState::ptr _state){
+  WorldStepWorldTimeState *state = assert_cast<WorldStepWorldTimeState*>(_state.get());
+
+  const int steps = getSteps(
+      state->params.steps_forward.get(),
+      state->params.steps_backward.get());
+
+  World::getInstance().setTime(state->oldtime+steps);
+  LOG(0, "Current time step is now: " << WorldTime::getTime() << ".");
+
+  return ActionState::ptr(_state);
+}
+
+bool WorldStepWorldTimeAction::canUndo() {
+  return true;
+}
+
+bool WorldStepWorldTimeAction::shouldUndo() {
+  return true;
+}
+/** =========== end of function ====================== */
Index: src/Actions/WorldAction/StepWorldTimeAction.def
===================================================================
--- src/Actions/WorldAction/StepWorldTimeAction.def	(revision d247507d666bbcdf34b0793aa013fb337a73385a)
+++ src/Actions/WorldAction/StepWorldTimeAction.def	(revision d247507d666bbcdf34b0793aa013fb337a73385a)
@@ -0,0 +1,38 @@
+/*
+ * StepWorldTimeAction.def
+ *
+ *  Created on: Sep 27, 2016
+ *      Author: heber
+ */
+
+// all includes and backward declarations necessary for non-integral types below
+
+
+#include "Parameters/Validators/DummyValidator.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (unsigned int)(unsigned int)
+#define paramtokens ("steps-forward")("steps-backward")
+#define paramdescriptions ("how many steps to take forward or backward")("how many steps to take forward or backward")
+#define paramdefaults (PARAM_DEFAULT(1))(PARAM_DEFAULT(0))
+#define paramreferences (steps_forward)(steps_backward)
+#define paramvalids \
+(DummyValidator< unsigned int >()) \
+(DummyValidator< unsigned int >())
+
+#define statetypes (unsigned int)
+#define statereferences (oldtime)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY World
+#define MENUNAME "world"
+#define MENUPOSITION 12
+#define ACTIONNAME StepWorldTime
+#define TOKEN "step-world-time"
+
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "step forward or backward a certain amount of steps in world time"
+#undef SHORTFORM
Index: src/Actions/WorldAction/StepWorldTimeAction.hpp
===================================================================
--- src/Actions/WorldAction/StepWorldTimeAction.hpp	(revision d247507d666bbcdf34b0793aa013fb337a73385a)
+++ src/Actions/WorldAction/StepWorldTimeAction.hpp	(revision d247507d666bbcdf34b0793aa013fb337a73385a)
@@ -0,0 +1,22 @@
+/*
+ * StepWorldTimeAction.hpp
+ *
+ *  Created on: Sep 27, 2016
+ *      Author: heber
+ */
+
+#ifndef STEPWORLDTIMEACTION_HPP_
+#define STEPWORLDTIMEACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/Action.hpp"
+
+#include "StepWorldTimeAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* STEPWORLDTIMEACTION_HPP_ */
